 
 
// <Template>
//   <SolutionTemplate>EF POCO 1</SolutionTemplate>
//   <Version>20110104.1</Version>
//   <Update>True</Update>
// </Template>
#region using
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using SFSdotNet.Framework.Entities.Metadata;
#endregion
namespace SFS.SampleApp.BusinessObjects
{

		  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class Address{
			public override string ToString()
            {
			
            	return this.AddressLine1.ToString();
			}

		//public Address()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.AddressID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 addressID)
            {
				_AddressID = addressID;

            }
			private Int32 _AddressID;
			[DataMember]
			public Int32 AddressID
			{
				get{
					return _AddressID;
				}
				set{
                     
					_AddressID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string AddressID = "AddressID";
            public static readonly string AddressLine1 = "AddressLine1";
            public static readonly string AddressLine2 = "AddressLine2";
            public static readonly string City = "City";
            public static readonly string StateProvince = "StateProvince";
            public static readonly string CountryRegion = "CountryRegion";
            public static readonly string PostalCode = "PostalCode";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string CustomerAddresses = "CustomerAddresses";
            public static readonly string SalesOrderHeaders = "SalesOrderHeaders";
            public static readonly string SalesOrderHeaders1 = "SalesOrderHeaders1";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class Customer{
			public override string ToString()
            {
			
            	return this.Title.ToString();
			}

		//public Customer()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.CustomerID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 customerID)
            {
				_CustomerID = customerID;

            }
			private Int32 _CustomerID;
			[DataMember]
			public Int32 CustomerID
			{
				get{
					return _CustomerID;
				}
				set{
                     
					_CustomerID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string CustomerID = "CustomerID";
            public static readonly string NameStyle = "NameStyle";
            public static readonly string Title = "Title";
            public static readonly string FirstName = "FirstName";
            public static readonly string MiddleName = "MiddleName";
            public static readonly string LastName = "LastName";
            public static readonly string Suffix = "Suffix";
            public static readonly string CompanyName = "CompanyName";
            public static readonly string SalesPerson = "SalesPerson";
            public static readonly string EmailAddress = "EmailAddress";
            public static readonly string Phone = "Phone";
            public static readonly string PasswordHash = "PasswordHash";
            public static readonly string PasswordSalt = "PasswordSalt";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string CustomerAddresses = "CustomerAddresses";
            public static readonly string SalesOrderHeaders = "SalesOrderHeaders";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class CustomerAddress{
			public override string ToString()
            {
			
            	return this.AddressType.ToString();
			}

		//public CustomerAddress()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.CustomerID.ToString());
						sb.Append("|");
					sb.Append(this.AddressID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 customerID, Int32 addressID)
            {
				_CustomerID = customerID;
				_AddressID = addressID;

            }
			private Int32 _CustomerID;
			[DataMember]
			public Int32 CustomerID
			{
				get{
					return _CustomerID;
				}
				set{
                     
					_CustomerID = value;
				}
	        }

			private Int32 _AddressID;
			[DataMember]
			public Int32 AddressID
			{
				get{
					return _AddressID;
				}
				set{
                     
					_AddressID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string CustomerID = "CustomerID";
            public static readonly string AddressID = "AddressID";
            public static readonly string AddressType = "AddressType";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string Address = "Address";
            public static readonly string Customer = "Customer";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class Product{
			public override string ToString()
            {
			
            	return this.Name.ToString();
			}

		//public Product()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.ProductID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 productID)
            {
				_ProductID = productID;

            }
			private Int32 _ProductID;
			[DataMember]
			public Int32 ProductID
			{
				get{
					return _ProductID;
				}
				set{
                     
					_ProductID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string ProductID = "ProductID";
            public static readonly string Name = "Name";
            public static readonly string ProductNumber = "ProductNumber";
            public static readonly string Color = "Color";
            public static readonly string StandardCost = "StandardCost";
            public static readonly string ListPrice = "ListPrice";
            public static readonly string Size = "Size";
            public static readonly string Weight = "Weight";
            public static readonly string SellStartDate = "SellStartDate";
            public static readonly string SellEndDate = "SellEndDate";
            public static readonly string DiscontinuedDate = "DiscontinuedDate";
            public static readonly string ThumbNailPhoto = "ThumbNailPhoto";
            public static readonly string ThumbnailPhotoFileName = "ThumbnailPhotoFileName";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string ProductCategory = "ProductCategory";
            public static readonly string ProductModel = "ProductModel";
            public static readonly string SalesOrderDetails = "SalesOrderDetails";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class ProductCategory{
			public override string ToString()
            {
			
            	return this.Name.ToString();
			}

		//public ProductCategory()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.ProductCategoryID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 productCategoryID)
            {
				_ProductCategoryID = productCategoryID;

            }
			private Int32 _ProductCategoryID;
			[DataMember]
			public Int32 ProductCategoryID
			{
				get{
					return _ProductCategoryID;
				}
				set{
                     
					_ProductCategoryID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string ProductCategoryID = "ProductCategoryID";
            public static readonly string Name = "Name";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string Products = "Products";
            public static readonly string ProductCategory1 = "ProductCategory1";
            public static readonly string ProductCategory2 = "ProductCategory2";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class ProductDescription{
			public override string ToString()
            {
			
            	return this.Description.ToString();
			}

		//public ProductDescription()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.ProductDescriptionID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 productDescriptionID)
            {
				_ProductDescriptionID = productDescriptionID;

            }
			private Int32 _ProductDescriptionID;
			[DataMember]
			public Int32 ProductDescriptionID
			{
				get{
					return _ProductDescriptionID;
				}
				set{
                     
					_ProductDescriptionID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string ProductDescriptionID = "ProductDescriptionID";
            public static readonly string Description = "Description";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string ProductModelProductDescriptions = "ProductModelProductDescriptions";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class ProductModel{
			public override string ToString()
            {
			
            	return this.Name.ToString();
			}

		//public ProductModel()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.ProductModelID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 productModelID)
            {
				_ProductModelID = productModelID;

            }
			private Int32 _ProductModelID;
			[DataMember]
			public Int32 ProductModelID
			{
				get{
					return _ProductModelID;
				}
				set{
                     
					_ProductModelID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string ProductModelID = "ProductModelID";
            public static readonly string Name = "Name";
            public static readonly string CatalogDescription = "CatalogDescription";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string Products = "Products";
            public static readonly string ProductModelProductDescriptions = "ProductModelProductDescriptions";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class ProductModelProductDescription{
			public override string ToString()
            {
				
				return base.ToString();
			}

		//public ProductModelProductDescription()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.ProductModelID.ToString());
						sb.Append("|");
					sb.Append(this.ProductDescriptionID.ToString());
						sb.Append("|");
					sb.Append(this.Culture.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 productModelID, Int32 productDescriptionID, String culture)
            {
				_ProductModelID = productModelID;
				_ProductDescriptionID = productDescriptionID;
				_Culture = culture;

            }
			private Int32 _ProductModelID;
			[DataMember]
			public Int32 ProductModelID
			{
				get{
					return _ProductModelID;
				}
				set{
                     
					_ProductModelID = value;
				}
	        }

			private Int32 _ProductDescriptionID;
			[DataMember]
			public Int32 ProductDescriptionID
			{
				get{
					return _ProductDescriptionID;
				}
				set{
                     
					_ProductDescriptionID = value;
				}
	        }

			private String _Culture;
			[DataMember]
			public String Culture
			{
				get{
					return _Culture;
				}
				set{
                     
					_Culture = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string ProductModelID = "ProductModelID";
            public static readonly string ProductDescriptionID = "ProductDescriptionID";
            public static readonly string Culture = "Culture";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string ProductDescription = "ProductDescription";
            public static readonly string ProductModel = "ProductModel";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class SalesOrderDetail{
			public override string ToString()
            {
				
				return base.ToString();
			}

		//public SalesOrderDetail()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.SalesOrderID.ToString());
						sb.Append("|");
					sb.Append(this.SalesOrderDetailID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 salesOrderID, Int32 salesOrderDetailID)
            {
				_SalesOrderID = salesOrderID;
				_SalesOrderDetailID = salesOrderDetailID;

            }
			private Int32 _SalesOrderID;
			[DataMember]
			public Int32 SalesOrderID
			{
				get{
					return _SalesOrderID;
				}
				set{
                     
					_SalesOrderID = value;
				}
	        }

			private Int32 _SalesOrderDetailID;
			[DataMember]
			public Int32 SalesOrderDetailID
			{
				get{
					return _SalesOrderDetailID;
				}
				set{
                     
					_SalesOrderDetailID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string SalesOrderID = "SalesOrderID";
            public static readonly string SalesOrderDetailID = "SalesOrderDetailID";
            public static readonly string OrderQty = "OrderQty";
            public static readonly string UnitPrice = "UnitPrice";
            public static readonly string UnitPriceDiscount = "UnitPriceDiscount";
            public static readonly string LineTotal = "LineTotal";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string Product = "Product";
            public static readonly string SalesOrderHeader = "SalesOrderHeader";
		}
		#endregion
	}
			  [Serializable()]
	  //[DataContract(IsReference=true)]
	  public partial class SalesOrderHeader{
			public override string ToString()
            {
			
            	return this.SalesOrderNumber.ToString();
			}

		//public SalesOrderHeader()
        //  {

        //  }

	  #region Composite Key
	   public string Key { 
                  get {
                      StringBuilder sb = new StringBuilder();
					sb.Append(this.SalesOrderID.ToString());
                      return sb.ToString();
                } 
		}
        [Serializable()]
        [DataContract]
        public class CompositeKey {
			
            public CompositeKey(Int32 salesOrderID)
            {
				_SalesOrderID = salesOrderID;

            }
			private Int32 _SalesOrderID;
			[DataMember]
			public Int32 SalesOrderID
			{
				get{
					return _SalesOrderID;
				}
				set{
                     
					_SalesOrderID = value;
				}
	        }

            
        }
        #endregion
        
	
             


	      #region propertyNames
        public struct PropertyNames {
            public static readonly string SalesOrderID = "SalesOrderID";
            public static readonly string RevisionNumber = "RevisionNumber";
            public static readonly string OrderDate = "OrderDate";
            public static readonly string DueDate = "DueDate";
            public static readonly string ShipDate = "ShipDate";
            public static readonly string Status = "Status";
            public static readonly string OnlineOrderFlag = "OnlineOrderFlag";
            public static readonly string SalesOrderNumber = "SalesOrderNumber";
            public static readonly string PurchaseOrderNumber = "PurchaseOrderNumber";
            public static readonly string AccountNumber = "AccountNumber";
            public static readonly string ShipMethod = "ShipMethod";
            public static readonly string CreditCardApprovalCode = "CreditCardApprovalCode";
            public static readonly string SubTotal = "SubTotal";
            public static readonly string TaxAmt = "TaxAmt";
            public static readonly string Freight = "Freight";
            public static readonly string TotalDue = "TotalDue";
            public static readonly string Comment = "Comment";
            public static readonly string rowguid = "rowguid";
            public static readonly string ModifiedDate = "ModifiedDate";
            public static readonly string Address = "Address";
            public static readonly string Address1 = "Address1";
            public static readonly string Customer = "Customer";
            public static readonly string SalesOrderDetails = "SalesOrderDetails";
		}
		#endregion
	}
	 
	
}
