using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SFS.SampleApp.Web.Mvc.Models.ProductModels;
using SFS.SampleApp.BR;
using System.Web.Script.Serialization;
using SFS.SampleApp.Web.Mvc.Models;
using SFS.SampleApp.Web.Mvc.Resources;
using BO = SFS.SampleApp.BusinessObjects;
using SFSdotNet.Framework.Web.Mvc.Security;
using SFSdotNet.Framework.Web.Mvc;
using SFSdotNet.Framework.Web.Mvc.Models;
using SFSdotNet.Framework.Web.Mvc.Resources;
using SFSdotNet.Framework.Web.Mvc.Controllers;
using MvcSiteMapProvider;
using System.Web.Routing;
//using SFS.SampleApp.BusinessObjects;
namespace SFS.SampleApp.Web.Mvc.Controllers
{
    public partial class ProductModelsController : SFSdotNet.Framework.Web.Mvc.ControllerBase
    {
        private RouteValueDictionary GetRouteData() {
            var popupextra = new RouteValueDictionary();

            foreach (var qs in Request.QueryString.AllKeys)
            {
                List<KeyValuePair<string, string>> extraparams = new List<KeyValuePair<string, string>>();

                if (!string.IsNullOrEmpty(Request.QueryString[qs]))
                {
                    popupextra.Add(qs, Request.QueryString[qs]);

                }
            }
            
            return popupextra;
        }


	#region partial methods
        ControllerEventArgs<Models.ProductModels.ProductModelModel> e = null;
        partial void OnValidating(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnCreating(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnCreated(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnEditing(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnEdited(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnDeleting(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnDeleted(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
    	partial void OnShowing(object sender, MyEventArgs<UIModel<Models.ProductModels.ProductModelModel>> e);
    	partial void OnGettingByKey(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
        partial void OnTaken(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
       	partial void OnCreateShowing(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
		partial void OnEditShowing(object sender, ControllerEventArgs<Models.ProductModels.ProductModelModel> e);
 		partial void OnActionsCreated(object sender, MyEventArgs<UIModel<Models.ProductModels.ProductModelModel >> e);
		partial void OnCustomActionExecuting(object sender, MyEventArgs<ContextActionModel<Models.ProductModels.ProductModelModel>> e);
        partial void OnDownloading(object sender, MyEventArgs<ContextActionModel<Models.ProductModels.ProductModelModel>> e);
      	partial void OnAuthorization(object sender, AuthorizationContext context);

	#endregion
#region Validation methods	
	    private void Validations(ProductModelModel model) { 
            #region Remote validations

            #endregion
		}

#endregion
		
 		public AuthorizationContext Authorization(AuthorizationContext context)
        {
            OnAuthorization(this,  context );
            return context ;
        }
		public List<ProductModelModel> GetAll() {
            			var bos = BR.ProductModelsBR.Instance.GetBy("",
					new SFSdotNet.Framework.My.ContextRequest()
					{
						CustomQuery = new SFSdotNet.Framework.My.CustomQuery()
						{
							OrderBy = "Name",
							SortDirection = SFSdotNet.Framework.Data.SortDirection.Ascending
						}
					});
            			List<ProductModelModel> results = new List<ProductModelModel>();
            ProductModelModel model = null;
            foreach (var bo in bos)
            {
                model = new ProductModelModel();
                model.Bind(bo);
                results.Add(model);
            }
            return results;

        }
        //
        // GET: /ProductModels/
		[MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ActionResult Index()
        {
    		var uiModel = GetContextModel(UIModelContextTypes.ListForm, null);
			
			uiModel.FilterStart = (string)ViewData["startFilter"];
                    MyEventArgs<UIModel<ProductModelModel>> me = null;

            OnActionsCreated(this, me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel });

            if (me != null)
            {
                uiModel = me.Object;
            }
            if (me == null)
                me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel };
           
            Showing(ref uiModel);
            ViewData["startFilter"] = uiModel.FilterStart;


            return View("ListGen");
        }
		[MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ActionResult ListViewGen()
        {
			ViewData["idTab"] = Request.QueryString["idTab"]; 
		 	ViewData["detpop"] = true; // details in popup
            if (!string.IsNullOrEmpty(Request.QueryString["fk"])) {
                ViewData["fk"] = Request.QueryString["fk"]; 
            }
			if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
            {
                ViewData["fkValue"] = Request.QueryString["fkValue"];
            }
			if (!string.IsNullOrEmpty(Request.QueryString["startFilter"]))
            {
                ViewData["startFilter"] = Request.QueryString["startFilter"];
            }
			
			UIModel<ProductModelModel> uiModel = GetContextModel(UIModelContextTypes.ListForm, null);

            MyEventArgs<UIModel<ProductModelModel>> me = null;

            OnActionsCreated(this, me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel });
            if (me == null)
                me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel };
            uiModel.Properties = GetProperties(uiModel);
            uiModel.ContextType = UIModelContextTypes.ListForm;
             uiModel.FilterStart = (string)ViewData["startFilter"];
            Showing(ref uiModel);
            ViewData["startFilter"] = uiModel.FilterStart;
            return View("ListViewGen");
        }
			
		private List<PropertyDefinition> GetProperties(UIModel<ProductModelModel> uiModel)
            {
                List<PropertyDefinition> results = new List<PropertyDefinition>();
			string idProductModel = "";
			if (this.Request.RequestContext.RouteData.Values["id"] != null){
				idProductModel = SFSdotNet.Framework.Entities.Utils.GetPropertyKey(this.Request.RequestContext.RouteData.Values["id"].ToString().Replace("-","/"), "ProductModelID");
			}
			bool visibleProperty = true;	
			 bool conditionalshow =false;
                if (uiModel.ContextType == UIModelContextTypes.EditForm || uiModel.ContextType == UIModelContextTypes.DisplayForm ||  uiModel.ContextType == UIModelContextTypes.GenericForm )
                    conditionalshow = true;
visibleProperty =true;
if (visibleProperty){				
	//Null
		//if (this.Request.QueryString["fk"] != "Name")
        //	{
				results.Add(new PropertyDefinition()
                {
													
		//			CustomProperties = customProperties,
                    PropertyName = "Name",
                    SortBy = "Name",
					
                    TypeName = "String",
                    IsNavigationProperty = false,
					IsNavigationPropertyMany = false,
                    PathName = "SFSSampleApp/",
                    PropertyDisplayName = Resources.ProductModelResources.NAME
                });
		//	}
	
	}
visibleProperty =true;
if (visibleProperty){				
	//Null
		//if (this.Request.QueryString["fk"] != "CatalogDescription")
        //	{
				results.Add(new PropertyDefinition()
                {
													
		//			CustomProperties = customProperties,
                    PropertyName = "CatalogDescription",
                    SortBy = "CatalogDescription",
					
                    TypeName = "String",
                    IsNavigationProperty = false,
					IsNavigationPropertyMany = false,
                    PathName = "SFSSampleApp/",
                    PropertyDisplayName = Resources.ProductModelResources.CATALOGDESCRIPTION
                });
		//	}
	
	}
visibleProperty =true;
if (visibleProperty){				
	//Null
		//if (this.Request.QueryString["fk"] != "ModifiedDate")
        //	{
				results.Add(new PropertyDefinition()
                {
													
		//			CustomProperties = customProperties,
                    PropertyName = "ModifiedDate",
                    SortBy = "ModifiedDate",
					
                    TypeName = "DateTime",
                    IsNavigationProperty = false,
					IsNavigationPropertyMany = false,
                    PathName = "SFSSampleApp/",
                    PropertyDisplayName = Resources.ProductModelResources.MODIFIEDDATE
                });
		//	}
	
	}
visibleProperty =true;
if (visibleProperty){				
	//FK_Product_ProductModel_ProductModelID
		//if (this.Request.QueryString["fk"] != "Products")
        //	{
				results.Add(new PropertyDefinition()
                {
												
					Link = VirtualPathUtility.ToAbsolute("~/") + "SFSSampleApp/Products/ListViewGen?pal=False&es=False&pag=20&idTab=Products&fk=ProductModel&startFilter="+ Url.Encode("ProductModel.ProductModelID = " + idProductModel +"")+ "&fkValue=" + idProductModel,
					
		//			CustomProperties = customProperties,
                    PropertyName = "Products",
                    SortBy = "Products.Name",
					
                    TypeName = "SFSSampleAppModel.Product",
                    IsNavigationProperty = true,
					IsNavigationPropertyMany = true,
                    PathName = "SFSSampleApp/Products",
                    PropertyDisplayName = Resources.ProductModelResources.PRODUCTS
                });
		//	}
	
	}
visibleProperty =true;
if (visibleProperty){				
	//FK_ProductModelProductDescription_ProductModel_ProductModelID
		//if (this.Request.QueryString["fk"] != "ProductModelProductDescriptions")
        //	{
				results.Add(new PropertyDefinition()
                {
												
					Link = VirtualPathUtility.ToAbsolute("~/") + "SFSSampleApp/ProductModelProductDescriptions/ListViewGen?pal=False&es=False&pag=20&idTab=ProductModelProductDescriptions&fk=ProductModel&startFilter="+ Url.Encode("ProductModel.ProductModelID = " + idProductModel +"")+ "&fkValue=" + idProductModel,
					
		//			CustomProperties = customProperties,
                    PropertyName = "ProductModelProductDescriptions",
                    SortBy = "ProductModelProductDescriptions.ProductModelID",
					
                    TypeName = "SFSSampleAppModel.ProductModelProductDescription",
                    IsNavigationProperty = true,
					IsNavigationPropertyMany = true,
                    PathName = "SFSSampleApp/ProductModelProductDescriptions",
                    PropertyDisplayName = Resources.ProductModelResources.PRODUCTMODELPRODUCTDESCRIPTIONS
                });
		//	}
	
	}
					
                
				return results;
            }

			
		
		public List<ProductModelModel> GetBy(string filter, int? pageSize, int? page, string orderBy, string orderDir,  params  object[] extraParams)
        {

		var bos = BR.ProductModelsBR.Instance.GetBy(HttpUtility.UrlDecode(filter), pageSize, page, orderBy, orderDir, extraParams);
            ProductModelModel model = null;
            List<ProductModelModel> results = new List<ProductModelModel>();
            foreach (var item in bos)
            {
                model = new ProductModelModel();
				model.Bind(item);
				results.Add(model);
            }
            return results;
        }
        [MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ContentResult GetByJson(string filter, int? pageSize, int? page, string orderBy, string orderDir)
        {
            var filteredResults = GetBy(HttpUtility.UrlDecode(filter), pageSize, page, orderBy, orderDir);
   			 UIModel<ProductModelModel> uiModel = GetContextModel(UIModelContextTypes.Items, null);
            uiModel.Items = filteredResults;
            Showing(ref uiModel);
            JavaScriptSerializer jsonSerializer = new JavaScriptSerializer();
            var jsonString = jsonSerializer.Serialize(uiModel.Items).ToString();
            return Content(jsonString);
        }
			
		public int GetByCount(string filter) {
            return BR.ProductModelsBR.Instance.GetCount(HttpUtility.UrlDecode(filter));
        }
		[MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ActionResult GetByKeyJson(string id)
        {
            return Json(GetByKey(id), JsonRequestBehavior.AllowGet);
        }
		public ProductModelModel GetByKey(string id) {
			return GetByKey(id, null);
       	}
		 public ProductModelModel GetByKey(string id, string includes) {
             ProductModelModel model = null;
            ControllerEventArgs<ProductModelModel> e = null;
			string objectKey = id.Replace("-","/");
             OnGettingByKey(this, e=  new ControllerEventArgs<ProductModelModel>() { Id = objectKey  });
             bool cancel = false;
             ProductModelModel eItem = null;
             if (e != null)
             {
                 cancel = e.Cancel;
                 eItem = e.Item;
             }
			if (cancel == false && eItem == null)
             {
		
			Int32 productModelID = Convert.ToInt32(SFSdotNet.Framework.Entities.Utils.GetPropertyKey(objectKey, "ProductModelID"));
            
				model = new ProductModelModel();
				var bo = BR.ProductModelsBR.Instance.GetByKey(productModelID, includes);
				if (bo!=null )
					model.Bind(bo);
			}
             else {
                 model = eItem;
             }
			model.IsNew = false;

            return model;
        }
        // GET: /ProductModels/DetailsGen/5
		[MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		[MvcSiteMapNode(AreaName="SFSSampleApp", Clickable=false, ParentKey = "SFSSampleApp_ProductModel_List")]
        public ActionResult DetailsGen(string id)
        {
			if (SiteMap.CurrentNode != null)
				SiteMap.CurrentNode.Title = ProductModelResources.ENTITY_PLURAL;
			UIModel<ProductModelModel> uiModel = GetContextModel(UIModelContextTypes.DisplayForm, GetByKey(id));
			
            MyEventArgs<UIModel<ProductModelModel>> me = null;

            OnActionsCreated(this, me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel });

            if (me != null) {
                uiModel = me.Object;
            }
			
            Showing(ref uiModel);
            if(!string.IsNullOrEmpty(Request.QueryString["popup"]))
                ViewData["ispopup"] = true;
			
            return View("DisplayGen", uiModel.Items[0]);
        }
		[MyAuthorize("r", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ActionResult DetailsViewGen(string id)
        {
			if(!string.IsNullOrEmpty(Request.QueryString["popup"]))
                ViewData["ispopup"] = true;
 			if (!string.IsNullOrEmpty(Request.QueryString["fk"]))
                ViewData["fk"] = Request.QueryString["fk"];
            if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
                ViewData["fkValue"] = Request.QueryString["fkValue"];
           
        	 var uiModel = GetContextModel(UIModelContextTypes.DisplayForm, GetByKey(id));
            MyEventArgs<UIModel<ProductModelModel>> me = null;

            OnActionsCreated(this, me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel });

            if (me != null)
            {
                uiModel = me.Object;
            }
            
            Showing(ref uiModel);
            return View("DisplayViewGen", uiModel.Items[0]);
        
        }
        //
        // GET: /ProductModels/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }
        //
        // GET: /ProductModels/CreateGen
		[MyAuthorize("c", "ProductModel",  ControllerType=typeof(ProductModelsController))]
        public ActionResult CreateGen()
        {
			ProductModelModel model = new ProductModelModel();
            model.IsNew = true;
			 var me = GetContextModel(UIModelContextTypes.EditForm, model);

             if (!string.IsNullOrEmpty(Request.QueryString["popup"]))
                 ViewData["ispopup"] = true;
             if (!string.IsNullOrEmpty(Request.QueryString["fk"]))
                 ViewData["fk"] = Request.QueryString["fk"];
             if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
                 ViewData["fkValue"] = Request.QueryString["fkValue"];

            Showing(ref me);

			return View("CreateGen",me.Items[0]);
        } 
			
		 private UIModel<ProductModelModel> GetContextModel(UIModelContextTypes formMode, ProductModelModel model) {
            UIModel<ProductModelModel> me = new UIModel<ProductModelModel>(true, "ProductModels");
			if (!string.IsNullOrEmpty(Request.QueryString["usemode"]))
				me.UseMode = Request.QueryString["usemode"];
			me.ContextType = formMode ;
            me.Properties = GetProperties(me);
 			#region Buttons
            me.ActionButtons.Add(new ActionModel() { ActionKey = "return", Title = GlobalMessages.RETURN, Url = System.Web.VirtualPathUtility.ToAbsolute("~/") + "SFSSampleApp/ProductModels" });
			if (!this.HttpContext.SkipAuthorization){
				me.SetAction("u", (new SFSdotNet.Framework.Globals.Security.Permission()).IsAllowed("u", "ProductModel", "SFSSampleApp"));
				me.SetAction("c", (new SFSdotNet.Framework.Globals.Security.Permission()).IsAllowed("c", "ProductModel", "SFSSampleApp"));
			
			}else{
				me.SetAction("u", true);
				me.SetAction("c", true);
			}
            #endregion              
         
            switch (formMode)
            {
                case UIModelContextTypes.DisplayForm:
					me.TitleForm = ProductModelResources.PRODUCTMODELS_DETAILS;
                    me.ActionButtons.First(p => p.ActionKey == "u").Title = GlobalMessages.EDIT;

                    break;
                case UIModelContextTypes.EditForm:
					if (model != null)
                    {
					                        me.ActionButtons.First(p => p.ActionKey == "c").Title = GlobalMessages.SAVE;
						if (model.IsNew ){
							me.TitleForm = ProductModelResources.PRODUCTMODELS_ADD_NEW;
							me.ActionName = "CreateGen";

						}else{
							me.ActionName = "EditGen";

							me.TitleForm = ProductModelResources.PRODUCTMODELS_EDIT;
						}
					}
                    break;
                case UIModelContextTypes.FilterFields:
                    break;
                case UIModelContextTypes.GenericForm:
                    break;
                case UIModelContextTypes.Items:
                    break;
                case UIModelContextTypes.ListForm:
					me.PrincipalActionName = "GetByJson";
					me.TitleForm = ProductModelResources.PRODUCTMODELS_LIST;
                    break;
                default:
                    break;
            }
            
			if (model != null )
            	me.Items.Add(model);
            return me;
        }
		// GET: /ProductModels/CreateViewGen
		[MyAuthorize("c", "ProductModel",  ControllerType=typeof(ProductModelsController))]
        public ActionResult CreateViewGen()
        {
				ProductModelModel model = new ProductModelModel();
            model.IsNew = true;
			e= null;
			OnCreateShowing(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
   			if (e!=null)
				model = e.Item;
			
				
            if(!string.IsNullOrEmpty(Request.QueryString["popup"]))
                ViewData["ispopup"] = true;
            if (!string.IsNullOrEmpty(Request.QueryString["fk"]))
                   ViewData["fk"] = Request.QueryString["fk"];
			if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
                ViewData["fkValue"] = Request.QueryString["fkValue"];
			
      
            var me = GetContextModel(UIModelContextTypes.EditForm, model);

            me.Items.Add(model);
            Showing(ref me);
            return View("EditorViewGen", me.Items[0]);
        }
		private void Showing(ref UIModel<ProductModelModel> uiModel) {
          	
			MyEventArgs<UIModel<ProductModelModel>> me = null;
            OnShowing(this, me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel });

            if (me != null)
            {
                uiModel = me.Object;
            }
            if (me == null)
                me = new MyEventArgs<UIModel<ProductModelModel>>() { Object = uiModel };
            ViewData["UIModel"] = uiModel;

        }
        //
        // POST: /ProductModels/Create
		[MyAuthorize("c", "ProductModel",  ControllerType=typeof(ProductModelsController))]
        [HttpPost]
		[ValidateInput(false)] 
        public ActionResult CreateGen(ProductModelModel  model)
        {
		 	e = null;
			this.Validations(model);

            OnValidating(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
           
		  	if (!ModelState.IsValid) {
				model.IsNew = true;
				var me = GetContextModel(UIModelContextTypes.EditForm, model);
                Showing(ref me);
                 if (!string.IsNullOrEmpty(Request.QueryString["popup"]))
                {
                    if (!string.IsNullOrEmpty(Request.QueryString["popup"]))
                        ViewData["ispopup"] = true;
                    if (!string.IsNullOrEmpty(Request.QueryString["fk"]))
                        ViewData["fk"] = Request.QueryString["fk"];
                    if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
                        ViewData["fkValue"] = Request.QueryString["fkValue"];

                    return View("EditorViewGen", model);
                }
                else
                    return View("CreateGen", model);
            }
            try
            {
	
				// habilitando m�todo parcial
                #region implementaci�n de m�todo parcial
               
                bool cancel = false; bool replaceResult = false;
                OnCreating(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
                if (e != null) {
                    if (e.Cancel && e.ActionResult != null)
                        return e.ActionResult;
                    else if (e.Cancel == true)
                        cancel = true;
                    else if (e.ActionResult != null)
                        replaceResult = true;
                }
                #endregion
                // si fue implementado el m�todo parcial y no se ha decidido suspender la acci�n
                if (!cancel)
                	model.Bind(ProductModelsBR.Instance.Create(model.GetBusinessObject()));
				OnCreated(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
                 if (e != null )
					if (e.ActionResult != null)
                    	replaceResult = true;		
				if (!replaceResult)
                {
                    if (!string.IsNullOrEmpty(Request.Form["__continue"]))
                    {
                        ViewData["__continue"] = true;
                    }
                    if (!string.IsNullOrEmpty(Request.QueryString["popup"]) || !string.IsNullOrEmpty(Request.Form["popup"]))
                    {
                        if (!string.IsNullOrEmpty(Request.Form["__continue"]))

                        {
                            var popupextra = GetRouteData();
                            popupextra.Add("id", model.SafeKey);
                            return RedirectToAction("EditViewGen", popupextra);
                        }
                        else
                        {
                            return PartialView("ResultMessageView", (new MessageModel()).GetDone(GlobalMessages.ADD_DONE));
                        }
                    }        			if (!string.IsNullOrEmpty(Request.QueryString["ReturnAfter"]))
                        return Redirect(Request.QueryString["ReturnAfter"]);
                    else{
                            if (!string.IsNullOrEmpty(Request.Form["__continue"])) {
                                                   var popupextra = GetRouteData();
                                popupextra.Add("id", model.SafeKey);
                                return RedirectToAction("EditGen", popupextra);

                            }
                            return RedirectToAction("Index");
                        }
						 }
                else {
                    return e.ActionResult;
                    }
				}
            catch
            {
                return View();
            }
        }        
        //
        // GET: /ProductModels/Edit/5 
        public ActionResult Edit(int id)
        {
            return View();
        }
			
		
		[MyAuthorize("u", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		[MvcSiteMapNode(AreaName="SFSSampleApp", Clickable=false, ParentKey = "SFSSampleApp_ProductModel_List")]
		public ActionResult EditGen(string id)
        {
			if (SiteMap.CurrentNode != null)
				SiteMap.CurrentNode.Title = ProductModelResources.ENTITY_SINGLE;		 	
  // habilitando m�todo parcial
            #region implementaci�n de m�todo parcial

            bool cancel = false; bool replaceResult = false;
            OnEditShowing(this, e = new ControllerEventArgs<ProductModelModel>() { Id= id });
            if (e != null)
            {
                if (e.Cancel && e.ActionResult != null)
                    return e.ActionResult;
                else if (e.Cancel == true)
                    cancel = true;
                else if (e.ActionResult != null)
                    replaceResult = true;
            }
            #endregion
            ProductModelModel model = null;
            // si fue implementado el m�todo parcial y no se ha decidido suspender la acci�n
            if (!cancel)
                model = GetByKey(id);
            else
                model = e.Item;
			 var me = GetContextModel(UIModelContextTypes.EditForm, model);
            Showing(ref me);


            if (!replaceResult)
            {
                 return View("EditGen", me.Items[0]);
            }
            else {
                return e.ActionResult;
            }
        }
			[MyAuthorize("u", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		public ActionResult EditViewGen(string id)
        {
            if (!string.IsNullOrEmpty(Request.QueryString["popup"]))
                ViewData["ispopup"] = true;
			  if (!string.IsNullOrEmpty(Request.QueryString["fk"]))
                ViewData["fk"] = Request.QueryString["fk"];
            if (!string.IsNullOrEmpty(Request.QueryString["fkValue"]))
                ViewData["fkValue"] = Request.QueryString["fkValue"];

					  // habilitando m�todo parcial
            #region implementaci�n de m�todo parcial

            bool cancel = false; bool replaceResult = false;
            OnEditShowing(this, e = new ControllerEventArgs<ProductModelModel>() { Id= id });
            if (e != null)
            {
                if (e.Cancel && e.ActionResult != null)
                    return e.ActionResult;
                else if (e.Cancel == true)
                    cancel = true;
                else if (e.ActionResult != null)
                    replaceResult = true;
            }
            #endregion
			
            ProductModelModel model = null;
            // si fue implementado el método parcial y no se ha decidido suspender la acción
            if (!cancel)
                model = GetByKey(id);
            else
                model = e.Item;
            var me = GetContextModel(UIModelContextTypes.EditForm, model);
            Showing(ref me);

            return View("EditorViewGen", me.Items[0]);
        }
		[MyAuthorize("u", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		[HttpPost]
		[ValidateInput(false)] 
        public ActionResult EditGen(ProductModelModel model)
        {
			e = null;
			this.Validations(model);

            OnValidating(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
           
            if (!ModelState.IsValid)
            {
			   	var me = GetContextModel(UIModelContextTypes.EditForm, model);
                Showing(ref me);
			
				if (!string.IsNullOrEmpty(Request.Form["popup"])){
                	ViewData["ispopup"] = true;
					return View("EditorViewGen", model);
				}
				else
					return View("EditGen", model);
            }
            try
            {
			
				// habilitando m�todo parcial
                #region implementaci�n de m�todo parcial
               
                bool cancel = false; bool replaceResult = false;
                OnEditing(this, e = new ControllerEventArgs<ProductModelModel>() { Item = model });
                if (e != null) {
                    if (e.Cancel && e.ActionResult != null)
                        return e.ActionResult;
                    else if (e.Cancel == true)
                        cancel = true;
                    else if (e.ActionResult != null)
                        replaceResult = true;
                }
                #endregion
                // si fue implementado el m�todo parcial y no se ha decidido suspender la acci�n
                if (!cancel)
                	ProductModelsBR.Instance.Update(model.GetBusinessObject());

                if (!string.IsNullOrEmpty(Request.QueryString["autosave"]))
                {
                    return Json("ok", JsonRequestBehavior.AllowGet);
                }
                else
                {
				if (!replaceResult)
                {
					if (!string.IsNullOrEmpty(Request.Form["popup"]))
						return PartialView("ResultMessageView", (new MessageModel()).GetDone(GlobalMessages.UPDATE_DONE));
        			if (!string.IsNullOrEmpty(Request.Form["ReturnAfter"]))
                        return Redirect(Request.Form["ReturnAfter"]);
                    else
                        return RedirectToAction("Index", new { usemode = Request.Form["usemode"]});
				 }
                else {
                    return e.ActionResult;
				}
                }		
            }
            catch
            {
                if (!string.IsNullOrEmpty(Request.QueryString["autosave"]))
                {
                    return Json("error", JsonRequestBehavior.AllowGet);
                }
                else {
                    return View();
                }
            }
        }
        //
        // POST: /ProductModels/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                //  Add update logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /ProductModels/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }
		[MyAuthorize("d", "ProductModel",  ControllerType=typeof(ProductModelsController))]
		[HttpDelete]
        public ActionResult DeleteGen(string objectKey, string extraParams)
        {
            try
            {
					
			
				Int32 productModelID = Convert.ToInt32(SFSdotNet.Framework.Entities.Utils.GetPropertyKey(objectKey.Replace("-", "/"), "ProductModelID")); 
                BO.ProductModel entity = new BO.ProductModel() { ProductModelID = productModelID };

                BR.ProductModelsBR.Instance.Delete(entity);               
                return PartialView("ResultMessageView", (new MessageModel()).GetDone(GlobalMessages.DELETE_DONE));

            }
            catch(Exception ex)
            {
                if (Request.IsAjaxRequest())
                {
                    string message = GlobalMessages.ERROR_TRY_LATER;
                    if (ex.Data["usermessage"] != null)
                    {
                        message = ex.Data["usermessage"].ToString();
                    }

                    return PartialView("ResultMessageView", (new MessageModel()).GetException(message));
                }
                else
                {
                    return View();
                }
            }
        }
			
		public FileMediaResult Download(string query, bool allSelected, string selected, string orderBy, string direction, string format, string actionKey)
        {
			
            List<Int32> keysSelected1 = new List<Int32>();
            if (!string.IsNullOrEmpty(selected)) {
                foreach (var keyString in selected.Split(char.Parse("|")))
                {
				
                    keysSelected1.Add(Int32.Parse(keyString));
                }
            }
				
            query = SFSdotNet.Framework.Web.Mvc.Lists.GetQuery(query, allSelected, selected, "ProductModelID");
            MyEventArgs<ContextActionModel<ProductModelModel>> eArgs = null;
            List<ProductModelModel> results = GetBy(query, null, null, orderBy, direction, keysSelected1);
            OnDownloading(this, eArgs = new MyEventArgs<ContextActionModel<ProductModelModel>>() { Object = new ContextActionModel<ProductModelModel>() { Query = query, SelectedItems = results, Selected=selected, SelectAll = allSelected, Direction = direction , OrderBy = orderBy, ActionKey=actionKey  } });

            if (eArgs != null)
            {
                if (eArgs.Object.Result != null)
                    return (FileMediaResult)eArgs.Object.Result;
            }
            

            return (new FeaturesController()).ExportDownload(typeof(ProductModelModel), results, format, ProductModelResources.PRODUCTMODELS_LIST);
            
        }
			
		
		[HttpPost]
        public ActionResult CustomActionExecute(ContextActionModel model) {
		 try
            {
			List<Int32> keysSelected1 = new List<Int32>();
            if (!string.IsNullOrEmpty(model.Selected))
            {
                foreach (var keyString in model.Selected.Split(char.Parse(",")))
                {
				
				keysSelected1.Add(Int32.Parse(keyString.Split(char.Parse("|"))[0]));
                        
                    

			
                }
            }

            model.Query = SFSdotNet.Framework.Web.Mvc.Lists.GetQuery(model.Query , model.SelectAll , model.Selected, "ProductModelID");
           
			List<ProductModelModel> results = GetBy(model.Query, null, null, model.OrderBy, model.Direction , keysSelected1);
			#region implementaci�n de m�todo parcial
            bool replaceResult = false;
            MyEventArgs<ContextActionModel<ProductModelModel>> actionEventArgs = null;
            OnCustomActionExecuting(this, actionEventArgs=new MyEventArgs<ContextActionModel<ProductModelModel>>() { Object= new ContextActionModel<ProductModelModel>() { ActionKey= model.ActionKey , Direction = model.Direction, OrderBy = model.OrderBy, SelectedItems = results, SelectedKeys = model.Selected, Query = model.Query } });
            if (model.ActionKey == "deletemany") { 
                // eliminar muchos, como una acci�n custom
                List<BO.ProductModel> entities = new List<BO.ProductModel>();
                foreach (var item in results)
                {
                    entities.Add(item.GetBusinessObject());
                }
                BR.ProductModelsBR.Instance.Delete(entities);


            }
			
                 if (actionEventArgs == null)
                {
                    if (model.ActionKey != "deletemany"  && model.ActionKey != "deleterelmany")
                    {
                        throw new NotImplementedException("");
                    }
                }
                else
                {
                    replaceResult = actionEventArgs.Object.Result is ActionResult /*actionEventArgs.Object.ReplaceResult*/;
                }
                #endregion
                if (!replaceResult)
                {
                    if (Request.IsAjaxRequest())
                    {
                        return PartialView("ResultMessageView", (new MessageModel()).GetDone(GlobalMessages.DONE));
                    }
                    else
                    {
                        return View();
                    }
                }
                else
                {
                    return (ActionResult)actionEventArgs.Object.Result;
                }
            }
            catch (Exception ex)
            {

                if (Request.IsAjaxRequest())
                {
                    string message = GlobalMessages.ERROR_TRY_LATER;
                    if (ex.Data["usermessage"] != null) {
                        message = ex.Data["usermessage"].ToString();
                    }

                    return PartialView("ResultMessageView", (new MessageModel()).GetException(message));
                }
                else
                {
                    return View();
                }

            }
        }
        //
        // POST: /ProductModels/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // Add delete logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
			
	
    }
}
